﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.IO.Ports;
using System.IO;


namespace Asynchronous2
{
    public partial class Form1 : Form
    {
        static String gReadText = "";
        static String gSendText = "";
        static Boolean fGo = false;//実行フラグ

        static Socket listener1;//Start
        static Socket listener2;//AcceptCallback
        static Socket handler2;//AcceptCallback
        static StateObject state3;//ReadCallback
        static Socket handler3;//ReadCallback
        static Socket handler4;//SendCallback

        static Int32 port;

        static String gText;//受信データ
        static int gX0 = 0;//X現在座標
        static int gY0 = 0;//Y現在座標
        static int gZ0 = 0;//Z現在座標
        static int gM = 0;//処理モード
        static int gS = 0;//シーケンスNo
        static int VthAD;//与圧の閾値
        static int gZ2 = 0;//Zサーチ結果
        static bool fOK = true;

        Bitmap image1;//入力画像データ
        static int[,] mZ = new int[120, 120];//加工面計測値
        static int[,] gMap = new int[120,120];//Mapデータ
        static int gW, gH;//画像幅、高さ
        static int gPw, gPh;//幅、高さ送りピッチ
        static int gi, gj;//幅、高さカウンタ

        static int fBX = 1;//バックラッシュフラグ
        static int gCT;//タイムカウンタ
        static int gCTN;//連続回転時間
        static int gCK;//'回数カウンタ
        static int gCKN;//加工回数

        static int gZSP;//サーチピッチ
        static int gi0Z;//gi=0時のZ退避量
        static int gi1Z;//gi>0時のZ退避量
        static int gKZ0;//加工開始Z位置
        int gKZP;//加工Z送り量
        int fVth = 0;//Vthフラグ

        static int gLT = 0;//ロスタイムカウンタ


        String[] fields;





        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            button21.Enabled = true;
            button23.Enabled = false;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {

        }

        private void button21_Click(object sender, EventArgs e)
        {
            port = Convert.ToInt32(textBox21.Text); 
            IPHostEntry ipHostInfo = Dns.Resolve(Dns.GetHostName());
            IPAddress ipAddress = ipHostInfo.AddressList[0];
            IPEndPoint localEndPoint = new IPEndPoint(ipAddress, port);
            listener1 = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            try
            {
                listener1.Bind(localEndPoint);
                listener1.Listen(100);
                fGo = true;//ロープ実行
                button21.Enabled = false;
                button23.Enabled = true;
                textBox23.AppendText("WiFi connected\r\n");
            }
            catch (Exception ex) { ;}
        }

        private void button22_Click(object sender, EventArgs e)
        {
            gSendText = gSendText + textBox22.Text + "\r\n";
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            
            if (fGo == true)
            {
                listener1.BeginAccept(new AsyncCallback(AcceptCallback),listener1);
                fGo = false;//実行停止
                textBox23.AppendText(gReadText);// textBox3にテキスト追加
                fields = gReadText.Split('\t');
                if (fields[0] == "MC")
                {
                    gX0 = Convert.ToInt32(fields[1]);
                    gY0 = Convert.ToInt32(fields[2]);
                    String str = fields[3].Substring(0, fields[3].IndexOf('\r'));
                    //String str = fields[3].Trim();//これはエラー！！
                    gZ0 = Convert.ToInt32(str);
                }
                if (fields[0] == "ZS")
                {
                    String str = fields[3].Substring(0, fields[3].IndexOf('\r'));
                    gZ2 = Convert.ToInt32(str);
                }
                //gText = gReadText;//受信データコピー
                gReadText = "";
                
            }

            if (fOK)
            {
                fOK = false;
                //TimeP();

                switch (gM)
                {
                    case 1:
                        //Zサーチ
                        //gZ2 = gZ0;
                        break;
                    case 2:
                        F2();//加工面計測
                        break;
                    case 3:
                        F3();//加工
                        break;
                    default:
                        break;
                }
                fOK = true;
            }

        }

        public static void AcceptCallback(IAsyncResult ar)
        {
            // Get the socket that handles the client request.
            listener2= (Socket)ar.AsyncState;
            handler2= listener2.EndAccept(ar);

            // Create the state object.
            StateObject state = new StateObject();
            state.workSocket = handler2;
            handler2.BeginReceive(state.buffer, 0, StateObject.BufferSize, 0,new AsyncCallback(ReadCallback), state);
        }

        public static void ReadCallback(IAsyncResult ar)
        {
            String content = String.Empty;

            // Retrieve the state object and the handler socket
            // from the asynchronous state object.
            state3 = (StateObject)ar.AsyncState;
            handler3 = state3.workSocket;

            // Read data from the client socket. 
            int bytesRead = handler3.EndReceive(ar);

            if (bytesRead > 0)
            {
                // There  might be more data, so store the data received so far.
                state3.sb.Append(Encoding.ASCII.GetString(state3.buffer, 0, bytesRead));
                content = state3.sb.ToString();
                if (content.IndexOf("\n") > -1)
                {
                    gReadText = content;
                    gText = gReadText;//受信データコピー
                }
                else
                {
                    //gReadText = content;
                }
                Send(handler3, gSendText);
                gSendText = "";
                fGo = true;
            }
        }

        private static void Send(Socket handler3, String data)
        {
            // Convert the string data to byte data using ASCII encoding.
            byte[] byteData = Encoding.ASCII.GetBytes(data);

            // Begin sending the data to the remote device.
           handler3.BeginSend(byteData, 0, byteData.Length, 0,new AsyncCallback(SendCallback), handler3);
        }

        private static void SendCallback(IAsyncResult ar)
        {
            try
            {
                // Retrieve the socket from the state object.
                handler4 = (Socket)ar.AsyncState;

                // Complete sending the data to the remote device.
                int bytesSent = handler4.EndSend(ar);
                //Console.WriteLine("Sent {0} bytes to client.", bytesSent);

                handler4.Shutdown(SocketShutdown.Both);
                handler4.Close();

            }
            catch (Exception ex)
            {
                //Console.WriteLine(e.ToString());
            }
            
        }

        private void Button5_Click(object sender, EventArgs e)
        {
            gSendText = gSendText +  "MA#0#0#0#\r\n";
            gX0 = 0;//X現在座標
            gY0 = 0;//Y現在座標
            gZ0 = 0;//'Z現在座標

            gM = 0;

        }

        private void Button1_Click(object sender, EventArgs e)
        {
            gM = 1;
            gSendText = gSendText + "ZS#" + TextBox5.Text + "#\r\n";
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            if (OpenFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox23.Text = "";
                image1 = new Bitmap(OpenFileDialog1.FileName);
                PictureBox1.Load(OpenFileDialog1.FileName);

                int x, y;
                TextBox1.Text = image1.Width.ToString();
                TextBox2.Text = image1.Height.ToString();

                gW = Convert.ToInt32(TextBox1.Text);
                gH = Convert.ToInt32(TextBox2.Text);
                gPw = Convert.ToInt32(TextBox3.Text);
                gPh = Convert.ToInt32(TextBox4.Text);

                gZSP = Convert.ToInt32(TextBox5.Text);
                gi0Z = Convert.ToInt32(TextBox6.Text);
                gi1Z = Convert.ToInt32(TextBox7.Text);
                gCTN = Convert.ToInt32(TextBox8.Text);
                gCKN = Convert.ToInt32(TextBox9.Text);
                gKZ0 = Convert.ToInt32(TextBox10.Text);
                gKZP = Convert.ToInt32(TextBox11.Text);

                for (y = 0; y < image1.Height; y++)
                {
                    for (x = 0; x < image1.Width; x++)
                    {
                        Color pixelColor = image1.GetPixel(x, image1.Height - 1 - y);
                        gMap[x, y] = pixelColor.R + pixelColor.G + pixelColor.B;
                        textBox23.AppendText(x.ToString() + "\t" + y.ToString() + "\t" + gMap[x, y].ToString() + "\r\n");
                        mZ[x, y] = 0;
                    }
                }

                gi = 0;
                gj = 0;
                gM = 2;
                gS = 0;
                textBox23.Text = "";
                textBox23.AppendText("i\tj\tgZ0\r\n");
            }
        }

        void F2()//加工面計測
        {
            String str;
            int x, y, z, AD;

            switch (gS)
            {
                case 0:
                    x = (gi+1 - gW / 2) * gPw;
                    y = (gj+1 - gH / 2) * gPh;
                    if (gi == 0)
                    {
                        z = gZ2 + gi0Z;//Zサーチ結果+gi=0時のZ退避量
                    }
                    else
                    {
                        z = gZ2 + gi1Z;//Zサーチ結果+gi=0時以外のZ退避量
                    }
                    gText = "";
                    gSendText = "MA#" + x.ToString() + "#" + y.ToString() + "#" + z.ToString() + "#\r\n";
                    gX0 = x; gY0 = y; gZ0 = z;
                    gS = gS+10;gLT = 0;//ロスタイム
                    break;
                case 10:
                    OKCheck(20);
                    break;
                case 20:
                    MCCheck(100);
                    break;
                case 30:
                    gSendText =  "ZS#" + TextBox5.Text + "#\r\n";
                    gS = gS+10;gLT = 0;//ロスタイム
                    break;
                case 40:
                    OKCheck(20);
                    break;
                case 50:
                    ZSCheck(100);
                    break;
                case 60:
                    mZ[gi, gj] = gZ0;mZ[gi+1, gj] = gZ0;mZ[gi+2, gj] = gZ0;
                    mZ[gi, gj+1] = gZ0;mZ[gi+1, gj+1] = gZ0;mZ[gi+2, gj+1] = gZ0;
                    mZ[gi, gj+2] = gZ0;mZ[gi+1, gj+2] = gZ0;mZ[gi+2, gj+2] = gZ0;

                    textBox23.AppendText(gi.ToString() + "\t" + gj.ToString() + "\t" + gZ0.ToString() + "\r\n");
                    if (gi < gW - 1)
                    {
                        //gi = gi + 1;
                        gi = gi + 3;
                        gS = 0;
                    }
                    else
                    {
                        if (gj < gH - 1)
                        {
                            gi = 0;
                            //gj = gj + 1;
                            gj = gj + 3;
                            gS = 0;
                        }
                        else
                        {
                            gS = gS+10;
                        }
                    }
                    break;
                case 70:
                    break;
                case 80:
                    break;
                default:
                    break;
            }
        }

        void OKCheck(int T)
        {
            String str;
            if (gText.Length > 2)
            {
                str = gText.Substring(0, 2);
                if (str == "OK") { gS = gS+10; }
            }
            gLT++;
            if (gLT > T) { gS = gS-10; }//ロスタイムオーバー
        }

        void ZSCheck(int T)
        {
            String str;
            if (gText.Length > 2)
            {
                str = gText.Substring(0, 2);
                if (str == "ZS") { gS = gS + 10; }
                //gText = "";
            }
            gLT++;
            if (gLT > T) { gS = gS - 20; }//ロスタイムオーバー
        }

        void MCCheck(int T)
        {
            String str;
            if (gText.Length > 2)
            {
                str = gText.Substring(0, 2);
                if (str == "MC") { gS = gS + 10; }
            }
            gLT++;
            if (gLT > T) { gS = gS - 20; }//タイムオーバー
        }

        void DCCheck(int T)
        {
            String str;
            if (gText.Length > 2)
            {
                str = gText.Substring(0, 2);
                if (str == "DC") { gS = gS + 10; }
            }
            gLT++;
            if (gLT > T) { gS = gS - 20; }//タイムオーバー
        }

        private void Button3_Click(object sender, EventArgs e)
        {
            int i, j;
            String OutText = "\\\t";

            for (i = 0; i < gW; i++)
            {
                OutText = OutText + "i=" + i.ToString() + "\t";
            }
            OutText = OutText + "\r\n";

            for (j = 0; j < gH; j++)
            {
                OutText = OutText + "j=" + j.ToString() + "\t";
                for (i = 0; i < gW; i++)
                {
                    OutText = OutText + mZ[i, j].ToString() + "\t";
                }
                OutText = OutText + "\r\n";
            }
            if (SaveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                using (StreamWriter outfile = new StreamWriter(SaveFileDialog1.FileName))
                {
                    outfile.Write(OutText);
                }
            }

        }

        private void Button4_Click(object sender, EventArgs e)
        {
            gW = Convert.ToInt32(TextBox1.Text);
            gH = Convert.ToInt32(TextBox2.Text);
            gPw = Convert.ToInt32(TextBox3.Text);
            gPh = Convert.ToInt32(TextBox4.Text);

            gZSP = Convert.ToInt32(TextBox5.Text);
            gi0Z = Convert.ToInt32(TextBox6.Text);
            gi1Z = Convert.ToInt32(TextBox7.Text);
            gCTN = Convert.ToInt32(TextBox8.Text);
            gCKN = Convert.ToInt32(TextBox9.Text);
            gKZ0 = Convert.ToInt32(TextBox10.Text);
            gKZP = Convert.ToInt32(TextBox11.Text);

            gi = 0;
            gj = 0;
            fBX = 1;
            gM = 3;
            gS = 0;

            textBox23.AppendText("\r\ni\tj\tgZ0\r\n");
        }

        void F3()//加工実行
        {
            String str;
            int x, y, z, AD;

            switch (gS)
            {
                case 0:
                    gCK = 1;
                    if (gMap[gi, gj] < 384)
                    { gS = gS + 10; }
                    else { gS = 270; }
                    break;
                case 10:
                    if (fBX == 1)
                    { gZ0 = gZ2 + gi0Z; }//Z退避初回相対移動
                    else { gZ0 = gZ2 + gi1Z; }//Z退避初回以外相対移動
                    gSendText = "MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#\r\n";
                    gS = gS+10;gLT = 0;//ロスタイム
                    break;
                case 20:
                    OKCheck(20);
                    break;
                case 30:
                    MCCheck(100);
                    break;
                case 40:
                    if (fBX == 1)
                    {
                        gX0 = (gi - gW / 2) * gPw - 500;//Xバックラッシュ補正
                        gY0 = (gj - gH / 2) * gPh - 500;//Yバックラッシュ補正
                        gZ0 = gZ2 + gi0Z;//Z退避初回
                        //初回絶対値移動
                        gText = "";
                        gSendText = "MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#\r\n";
                        //gX0 = x; gY0 = y; gZ0 = z;
                        fBX = 0;//初回完了
                        gS = gS + 10; gLT = 0;//ロスタイム
                    }
                    else
                    {
                        gS = 70;
                    }
                    break;
                case 50:
                    OKCheck(20);
                    break;
                case 60:
                    MCCheck(100);
                    break;
                case 70:
                    gX0 = (gi - gW / 2) * gPw;
                    gY0 = (gj - gH / 2) * gPh;
                    if (fBX == 1)
                    { gZ0 = gZ2 + gi0Z; }//初回加工Z位置
                    else { gZ0 = gZ2 + gi1Z; }//初回以外加工Z位置
                    gText = "";
                    gSendText = "MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#\r\n";
                    //gX0 = x; gY0 = y; gZ0 = z;
                    gS = gS + 10; gLT = 0;//ロスタイム
                    break;
                case 80:
                    OKCheck(20);
                    break;
                case 90:
                    MCCheck(100);
                    break;
                case 100:
                    textBox23.AppendText(gi.ToString() + "\t" + gj.ToString() + "\t" + mZ[gi, gj].ToString() + "\r\n");
                    gS = gS+10;gLT = 0;//ロスタイム
                    break;
                case 110:
                    gZ0 = mZ[gi, gj] + gKZ0;
                    gText = "";
                    gSendText = "MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#\r\n";
                    gS = gS+10;gLT = 0;//ロスタイム
                    break;
                case 120:
                    OKCheck(20);
                    break;
                case 130:
                    MCCheck(100);
                    break;
                case 140:
                    gText = "";
                    gSendText = "DC#1#\r\n";
                    gCT = 0;// タイムカウンタ
                    //gCK = 0;//回数カウンタ
                    gS = gS+10;gLT = 0;//ロスタイム
                    break;
                case 150:
                    //OKCheck(20);
                    gS = gS+10;gLT = 0;//ロスタイム
                    break;
                case 160:
                    DCCheck(20);
                    break;
                case 170:
                    if (gCT > gCTN)
                    {
                        gCT = 0;
                        gS = gS + 10; gLT = 0;//ロスタイム
                    }
                    else { gCT = gCT + 1; }//タイムカウンタUP
                    break;
                case 180:
                    gText = "";
                    gSendText = "DC#0#\r\n";
                    gS = gS + 10; gLT = 0;//ロスタイム
                    break;
                case 190:
                    //OKCheck(20);
                    gS = gS+10;gLT = 0;//ロスタイム
                    break;
                case 200:
                    DCCheck(20);
                    break;
                case 210:
                    gS = gS + 10;
                    break;
                case 220:
                    if (gCK < gCKN)
                    {
                        gCK = gCK + 1;//回数カウンタUP
                        gS = gS + 10; gLT = 0;//ロスタイム
                    }
                    else
                    {gS = 270;}//1点加工完了
                    break;
                case 230:
                    gX0 = (gi - gW / 2) * gPw;
                    gY0 = (gj - gH / 2) * gPh;
                    gZ0 = mZ[gi, gj] + gKZ0 + gKZP * (gCK - 1);
                    gText = "";
                    gSendText = "MA#" + gX0.ToString() + "#" + gY0.ToString() + "#" + gZ0.ToString() + "#\r\n";
                    gS = gS + 10; gLT = 0;//ロスタイム
                    break;
                case 240:
                    OKCheck(20);
                    break;
                case 250:
                    MCCheck(100);
                    break;
                case 260:
                    //gS = 170;
                    gS = 140;
                    break;
                case 270:
                    if (gi < gW - 1)
                    {
                        gi = gi + 1;
                        gS = 0;//最初に戻る
                    }
                    else//X方向の全点完了
                    {
                        if (gj < gH - 1)
                        {
                            fBX = 1;//バックラッシュフラグON
                            gi = 0;//X方向位置
                            gj = gj + 1;//Y方向位置UP
                            gS = 0;//最初に戻る
                        }
                        else { gS = gS+10; }//全加工完了！！
                    }
                    break;
                case 280:
                    gSendText = gSendText + "MA#0#0#0#\r\n";
                    gS = gS + 10; gLT = 0;//ロスタイム
                    break;
                case 290:
                    OKCheck(20);
                    break;
                case 300:
                    MCCheck(100);
                    break;
                case 310:
                    break;
                default:
                    break;
            }

        }


       

  
    }

    



    // State object for reading client data asynchronously
    public class StateObject
    {
        // Client  socket.
        public Socket workSocket = null;
        // Size of receive buffer.
        public const int BufferSize = 1024;
        // Receive buffer.
        public byte[] buffer = new byte[BufferSize];
        // Received data string.
        public StringBuilder sb = new StringBuilder();
    }

}
